package com.eactive.eai.adapter.socket2.protocol.law.codec;

import com.eactive.eai.adapter.EAIException;
import com.eactive.eai.adapter.socket2.common.CommonLib;
import com.eactive.eai.adapter.socket2.common.SMSLogger;
import com.eactive.eai.adapter.socket2.config.SocketAdapterContext;
import com.eactive.eai.adapter.socket2.config.SocketLoggerManager;
import com.eactive.eai.adapter.socket2.protocol.ByteMessage;
import com.eactive.eai.adapter.socket2.protocol.ISocketAdapter;
import com.eactive.eai.adapter.socket2.protocol.ProtocolHandler;
import com.eactive.eai.common.util.Logger;
import org.apache.mina.common.ByteBuffer;
import org.apache.mina.common.IdleStatus;
import org.apache.mina.common.IoSession;
import org.apache.mina.filter.codec.ProtocolDecoderAdapter;
import org.apache.mina.filter.codec.ProtocolDecoderOutput;

public class LawSendDecoder extends ProtocolDecoderAdapter  {
	protected final Logger logger;
	protected final Logger errLogger;
	
	public static final int MAX_PAYLOAD_SIZE = 25 * 1024 * 1024;   // 25MB

	private static final String DECODER_STATE_KEY = LawSendDecoder.class.getName() + ".STATE";

	private enum State {
		STATE_HEADER_READ, STATE_PAYLOAD_READ;
	}

	private static class CodecState {
		State       state = State.STATE_HEADER_READ; 
		ByteBuffer 	buffer = ByteBuffer.allocate(0).setAutoExpand(true);
		int      	payloadSize;
	}
	
	SocketAdapterContext context;
	ISocketAdapter adapter;

	public LawSendDecoder(ISocketAdapter adapter) {
		this.adapter = adapter;
		this.context = adapter.getContext();

	    logger    = SocketLoggerManager.getInstance().getLogger(context.getAdapterGroupName());
	    errLogger = SocketLoggerManager.getInstance().getErrLogger();
	}

	@SuppressWarnings("static-access")
	public void decode(IoSession session, ByteBuffer in, ProtocolDecoderOutput out) throws Exception {
		CodecState codecState = (CodecState) session.getAttribute(DECODER_STATE_KEY);
		if (codecState == null) {
			codecState = new CodecState();
			codecState.buffer.limit(LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH);
			session.setAttribute(DECODER_STATE_KEY, codecState);
		}

		if ( context.getTraceLevel() >= context.TRACE_LEVEL_TRACE ) {
			StringBuilder sb = new StringBuilder();
			sb.append("LawSendDecoder");
			if (codecState.state == State.STATE_PAYLOAD_READ) {
				sb.append("(" + codecState.payloadSize + ")");
			}
			sb.append(" | decode : " + CommonLib.hexDump(in, context));
			logger.debug(sb.toString());
			adapter.addRecentRecvTrace(session, sb.toString());
		}

		while(in.hasRemaining()) {
			session.setIdleTime(IdleStatus.BOTH_IDLE, context.getTimeout());

			switch (codecState.state) {
			case STATE_HEADER_READ:		
				if (readHeader(session, codecState, in)) {
					/**
					 * payload size < 0 인 경우
					 */
					if (codecState.payloadSize < 0) {
						throw new EAIException("RECEAINNA008", context.getAdapterName() +
								" (" + context.getLlFieldType() + "," + LawConstants.LL_FIELD_OFFSET_LENGTH + "," + LawConstants.LL_FIELD_LENGTH +
								") | when read header, ll length field is invalid | " + CommonLib.hexDump(codecState.buffer, context));						
					/**
					 * payload size == 0 인 경우
					 */
					} else if (codecState.payloadSize == 0) {
						if (context.isSync()) {
							throw new Exception("<RECV> payload size 0 (ping). 'SYNC' response type socket does not support ping(size 0) message.");
						}

			 			//codecState.state = State.STATE_HEADER_READ;
						session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());

			 			if ( context.getTraceLevel() >= context.TRACE_LEVEL_INFO ) {
							logger.info(context.getAdapterName() + " | <RECV> payload size 0 (ping) -> ignore. - " + CommonLib.hexDump(in, context));
							adapter.addRecentRecvTrace(session, "payload size 0 (ping) -> ignore. - " + CommonLib.hexDump(in, context));
						}

			 			/**
						 * header 값을 읽은 후 buffer의 position을 이동해 준다.
						 * 이 작업을 안해주면 무한루프에 빠질 수 있다.
						 * 예) 법원 공탁금 (_LAW_IN_SOC_AsS{...})
						 */
						codecState.buffer.position(0).limit(LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH);
						
						//by short11
						//polling.role 이 Server 가 sender일 경우 오류가 있었음
						if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
						}else{
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
						}


						break;
					}
					
					/**
					 * ll.include = 'Y' - LL을 포함해서 넘긴다.
					 */
					try {
						codecState.buffer.position(LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH)
						                   .limit(codecState.payloadSize + LawConstants.LL_FIELD_LENGTH);
					} catch(IllegalArgumentException e) {
						StringBuilder sb = new StringBuilder();
						sb.append(context.getAdapterName() + " | error when handling buffer | ");							
						sb.append("offset=" + LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH);
						sb.append(", limit=" + codecState.payloadSize + LawConstants.LL_FIELD_LENGTH);
						logger.error(sb.toString());
		    			errLogger.error(sb.toString());
		    			adapter.addRecentError(sb.toString());
		    			SMSLogger.loggingSMS4Soc(context.getAdapterName(), context.getDescription(), "RECEAINNA007");
						throw e;
					}
					
					/**
					 * offset + ll 을 읽었고, 더 이상 읽을 것(payload)이 없는 경우
					 * - ll.length value = ll.offset + ll.field.length
					 */
					if (codecState.buffer.position() == codecState.buffer.limit()) {
						byte[] bytes = new byte[codecState.buffer.limit()];
						codecState.buffer.position(0);
						codecState.buffer.get(bytes);
						ByteMessage message = new ByteMessage(bytes);	
						out.write(message);
						codecState.buffer.position(0).limit(LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH);
						
						
						
						//by short11
						//polling.role 이 Server 가 sender일 경우 오류가 있었음
						if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
						}else{
							session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
						}
						
					
						break;
					}
						
					codecState.state = State.STATE_PAYLOAD_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				break;
			case STATE_PAYLOAD_READ:
				if (readPayload(session, codecState, in)) {
					byte[] bytes = new byte[codecState.buffer.limit()];
					codecState.buffer.position(0);
					codecState.buffer.get(bytes);
					ByteMessage message = new ByteMessage(bytes);
					out.write(message);
					
					codecState.buffer.position(0).limit(LawConstants.LL_FIELD_OFFSET_LENGTH + LawConstants.LL_FIELD_LENGTH);
					
					//by short11
					//polling.role 이 Server 가 sender일 경우 오류가 있었음
					if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
					}else{
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
					}

		 			codecState.state = State.STATE_HEADER_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				
				break;
			}
			
			session.setAttribute(ProtocolHandler.CODEC_STATE_BUFFER, CommonLib.hexDumpRead(codecState.buffer, context));
		}
	}

	private boolean readHeader(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {

        if (codecState.buffer.remaining() > in.remaining()) {
        	codecState.buffer.put(in);
            return false;
        }

    	while(codecState.buffer.hasRemaining()) {
    		codecState.buffer.put(in.get());
    	}
    	codecState.payloadSize = 0;
    	
		byte[] header = new byte[LawConstants.LL_FIELD_LENGTH];				
		for (int i=0; i<LawConstants.LL_FIELD_LENGTH; i++) {
			header[i] = codecState.buffer.get(LawConstants.LL_FIELD_OFFSET_LENGTH + i);
		}
		
		codecState.payloadSize = getInt(header) ;

		if (codecState.payloadSize > MAX_PAYLOAD_SIZE) {
			throw new Exception("max payload size(" + MAX_PAYLOAD_SIZE + ") exceeded : " + 
					            codecState.payloadSize + " | " + 
					            CommonLib.hexDump(codecState.buffer, context));
		}
		/**
		 * ll.field.include = 'Y' - 헤더 길이를 빼 준다.
		 */
		if (true) {
			codecState.payloadSize = codecState.payloadSize - LawConstants.LL_FIELD_LENGTH;
		}		

		return true;
	}

	private boolean readPayload(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {

        if (codecState.buffer.remaining() > in.remaining()) {
        	codecState.buffer.put(in);
            return false;
        }
        
    	while(codecState.buffer.hasRemaining()) {
    		codecState.buffer.put(in.get());
    	}
		
		return true;
	}

	private int getInt(byte[] header) throws Exception{
		String h = new String(header);
		String len = h.replaceAll(" ", "");
		return Integer.parseInt(len);
	}
	
	
}
